/* This demo shows the use of a browser and a file selector.

   Written by Mark Overmars

   Date 29 Apr 1991
*/

#include <stdio.h>
#include "forms.h"

FL_FORM *form;
FL_OBJECT *br, *but;

void load_file(FL_OBJECT *ob, long arg)
{
  char *fname;
  fname = fl_show_file_selector("File To Load","","","");
  if (fname == NULL) return;
  if (! fl_load_browser(br,fname)) fl_add_browser_line(br,"NO SUCH FILE!");
}
 
void set_size(FL_OBJECT *ob, long arg)
{
  if (arg == 0) fl_set_browser_fontsize(br,FL_SMALL_FONT);
  if (arg == 1) fl_set_browser_fontsize(br,FL_NORMAL_FONT);
  if (arg == 2) fl_set_browser_fontsize(br,FL_LARGE_FONT);
}

void create_form()
{
  FL_OBJECT *obj;
  form = fl_bgn_form(FL_NO_BOX,590.0,610.0);
  obj = fl_add_box(FL_UP_BOX,0.0,0.0,590.0,610.0,"");
  br = obj = fl_add_browser(FL_NORMAL_BROWSER,20.0,60.0,550.0,530.0,"");
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,140.0,20.0,100.0,30.0,"Small");
    fl_set_call_back(obj,set_size,0);
  obj = fl_add_button(FL_NORMAL_BUTTON,20.0,20.0,100.0,30.0,"Load");
    fl_set_call_back(obj,load_file,0);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,240.0,20.0,100.0,30.0,"Normal");
    fl_set_call_back(obj,set_size,1);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,340.0,20.0,100.0,30.0,"Large");
    fl_set_call_back(obj,set_size,2);
  but = fl_add_button(FL_NORMAL_BUTTON,460.0,20.0,100.0,30.0,"Exit");
  fl_end_form();
}

main()
{
  FL_OBJECT *obj;
  fl_init();
  create_form();

  fl_clear_browser(br);
  fl_add_browser_line(br,"LOAD A FILE.");
  fl_set_browser_fontstyle(br,FL_FIXED_STYLE);

  fl_show_form(form,FL_PLACE_SIZE,TRUE,"Browser");
  do { obj = fl_do_forms(); }  while (obj != but);
  fl_hide_form(form);
}
